﻿' The MIT License (MIT)
' 
' COPYRIGHT 2013. BLOOMBERG FINANCE L.P.
' 
' Permission is hereby granted, free of charge, to any person obtaining a copy
' of this software and associated documentation files (the "Software"), to deal
' in the Software without restriction, including without limitation the rights
' to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
' copies of the Software, and to permit persons to whom the Software is
' furnished to do so, subject to the following conditions:
' 
' The above copyright notice and this permission notice shall be included in
' all copies or substantial portions of the Software.
' 
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
' FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
' AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
' LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
' OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
' THE SOFTWARE.

Imports System.Collections.Specialized
Imports System.Globalization
Imports System.Runtime.Remoting
Imports System.Runtime.Remoting.Channels
Imports System.Runtime.Remoting.Channels.Ipc
Imports System.Runtime.Serialization.Formatters

Namespace PluginHost.Hosting
	Public Class HostProcess
		Inherits MarshalByRefObject
        Public Property Controller As PluginController

		Public Sub New()
			Dim channel = New IpcServerChannel(New ListDictionary From {{"portName", RemotingConfiguration.ProcessId}}, New BinaryServerFormatterSinkProvider With {.TypeFilterLevel = TypeFilterLevel.Full})

			ChannelServices.RegisterChannel(channel, False)

            Dim args() As String = {Process.GetCurrentProcess.Id.ToString(CultureInfo.InvariantCulture), channel.GetUrlsForUri(RemotingServices.Marshal(Me).URI)(0)}

			Process.Start(New ProcessStartInfo With {.FileName = "PluginHost.Hosting.Host.exe", .Arguments = String.Join(" ", args), .UseShellExecute = False, .CreateNoWindow = True})
		End Sub
	End Class
End Namespace